diff -uNr --exclude autom4te.cache --exclude 'configure*' --exclude '*.orig' digikam-0.8.0/digikam/digikam/digikamapp.cpp digikam-0.8.0-lz/digikam/digikam/digikamapp.cpp
--- digikam-0.8.0/digikam/digikam/digikamapp.cpp	2005-11-21 21:14:05.000000000 +0200
+++ digikam-0.8.0-lz/digikam/digikam/digikamapp.cpp	2005-12-10 14:51:51.000000000 +0200
@@ -121,6 +121,9 @@
     populateThemes();
 
     setAutoSaveSettings();
+    
+    mDcopIface = new DigikamIface(this, "DigiKamIface");
+    connect(mDcopIface, SIGNAL(signalCameraAutoDetect()), this, SLOT(slotCameraAutoDetect()));
 
     // Auto-detect camera if requested so
     if (detectCamera)
diff -uNr --exclude autom4te.cache --exclude 'configure*' --exclude '*.orig' digikam-0.8.0/digikam/digikam/digikamapp.h digikam-0.8.0-lz/digikam/digikam/digikamapp.h
--- digikam-0.8.0/digikam/digikam/digikamapp.h	2005-11-21 21:14:05.000000000 +0200
+++ digikam-0.8.0-lz/digikam/digikam/digikamapp.h	2005-12-10 15:13:08.000000000 +0200
@@ -38,6 +38,7 @@
 #include <kapplication.h>
 #include <kmainwindow.h>
 #include "digikam_export.h"
+#include "digikamiface.h"
 
 namespace KIPI
 {
@@ -183,6 +184,7 @@
     KAction       *mTipAction;
     KAction       *mKipiHelpAction;
     KAction       *mGammaAdjustmentAction;
+    DigikamIface  *mDcopIface;
 
 private slots:
 
diff -uNr --exclude autom4te.cache --exclude 'configure*' --exclude '*.orig' digikam-0.8.0/digikam/digikam/digikamiface.cpp digikam-0.8.0-lz/digikam/digikam/digikamiface.cpp
--- digikam-0.8.0/digikam/digikam/digikamiface.cpp	1970-01-01 03:00:00.000000000 +0300
+++ digikam-0.8.0-lz/digikam/digikam/digikamiface.cpp	2005-12-10 14:56:18.000000000 +0200
@@ -0,0 +1,30 @@
+//
+// C++ Implementation: digikamiface
+//
+// Description: 
+//
+//
+// Author: digiKam team <digikam-devel@kde.org>, (C) 2005
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+#include "digikamiface.h"
+
+DigikamIface::DigikamIface(QObject *parent, const char *name)
+ : QObject(parent, name), DCOPObject(name)
+{
+}
+
+
+DigikamIface::~DigikamIface()
+{
+}
+
+void DigikamIface::cameraAutoDetect()
+{
+  emit signalCameraAutoDetect();
+}
+
+
+#include "digikamiface.moc"
diff -uNr --exclude autom4te.cache --exclude 'configure*' --exclude '*.orig' digikam-0.8.0/digikam/digikam/digikamiface.h digikam-0.8.0-lz/digikam/digikam/digikamiface.h
--- digikam-0.8.0/digikam/digikam/digikamiface.h	1970-01-01 03:00:00.000000000 +0300
+++ digikam-0.8.0-lz/digikam/digikam/digikamiface.h	2005-12-10 14:51:22.000000000 +0200
@@ -0,0 +1,35 @@
+//
+// C++ Interface: digikamiface
+//
+// Description: 
+//
+//
+// Author: digiKam team <digikam-devel@kde.org>, (C) 2005
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+#ifndef DIGIKAMIFACE_H
+#define DIGIKAMIFACE_H
+
+#include <qobject.h>
+#include <dcopobject.h>
+
+/**
+@author digiKam team
+*/
+class DigikamIface : public QObject, public DCOPObject
+{
+    K_DCOP
+    Q_OBJECT
+public:
+    DigikamIface(QObject *parent = 0, const char *name = 0);
+    ~DigikamIface();
+signals:        
+    void signalCameraAutoDetect();
+public:    
+k_dcop:
+    void cameraAutoDetect();    
+};
+
+#endif
diff -uNr --exclude autom4te.cache --exclude 'configure*' --exclude '*.orig' digikam-0.8.0/digikam/digikam/Makefile.am digikam-0.8.0-lz/digikam/digikam/Makefile.am
--- digikam-0.8.0/digikam/digikam/Makefile.am	2005-11-21 21:14:05.000000000 +0200
+++ digikam-0.8.0-lz/digikam/digikam/Makefile.am	2005-12-10 14:54:23.000000000 +0200
@@ -44,7 +44,8 @@
 			searchquickdialog.cpp searchadvanceddialog.cpp \
 			searchwidgets.cpp kdateedit.cpp kdatetimeedit.cpp \
 			kdatepickerpopup.cpp folderview.cpp folderitem.cpp \
-			upgradedb_sqlite2tosqlite3.cpp squeezedcombobox.cpp
+			upgradedb_sqlite2tosqlite3.cpp squeezedcombobox.cpp \
+			digikamiface.cpp digikamiface.skel
 
 
 libdigikam_la_LIBADD  = $(LIB_KIO) $(LIB_SQLITE3) $(LIB_KABC) \
@@ -95,3 +96,4 @@
 KDE_OPTIONS = nofinal
 
 include ../../admin/Doxyfile.am
+noinst_HEADERS = digikamiface.h