Index: imageproperties/cameraitempropertiestab.cpp
===================================================================
--- imageproperties/cameraitempropertiestab.cpp	(révision 656709)
+++ imageproperties/cameraitempropertiestab.cpp	(copie de travail)
@@ -212,8 +212,50 @@
     d->labelPhotoFlash        = new KSqueezedTextLabel(0, d->settingsArea);
     d->labelPhotoWhiteBalance = new KSqueezedTextLabel(0, d->settingsArea);
 
+    int hgt = fontMetrics().height()+2;
     d->title->setAlignment(Qt::AlignCenter);
+    d->file->setMaximumHeight(hgt);
+    d->folder->setMaximumHeight(hgt);
+    d->date->setMaximumHeight(hgt);
+    d->size->setMaximumHeight(hgt);
+    d->isReadable->setMaximumHeight(hgt);
+    d->isWritable->setMaximumHeight(hgt);
+    d->mime->setMaximumHeight(hgt);
+    d->dimensions->setMaximumHeight(hgt);
+    d->newFileName->setMaximumHeight(hgt);
+    d->downloaded->setMaximumHeight(hgt);
+    d->labelFile->setMaximumHeight(hgt);
+    d->labelFolder->setMaximumHeight(hgt);
+    d->labelFileDate->setMaximumHeight(hgt);
+    d->labelFileSize->setMaximumHeight(hgt);
+    d->labelFileIsReadable->setMaximumHeight(hgt);
+    d->labelFileIsWritable->setMaximumHeight(hgt);
+    d->labelImageMime->setMaximumHeight(hgt);
+    d->labelImageDimensions->setMaximumHeight(hgt);
+    d->labelNewFileName->setMaximumHeight(hgt);
+    d->labelAlreadyDownloaded->setMaximumHeight(hgt);
+
     d->title2->setAlignment(Qt::AlignCenter);
+    d->make->setMaximumHeight(hgt);
+    d->model->setMaximumHeight(hgt);
+    d->photoDate->setMaximumHeight(hgt);
+    d->aperture->setMaximumHeight(hgt);
+    d->focalLength->setMaximumHeight(hgt);
+    d->exposureTime->setMaximumHeight(hgt);
+    d->sensitivity->setMaximumHeight(hgt);
+    d->exposureMode->setMaximumHeight(hgt);
+    d->flash->setMaximumHeight(hgt);
+    d->whiteBalance->setMaximumHeight(hgt);
+    d->labelPhotoMake->setMaximumHeight(hgt);
+    d->labelPhotoModel->setMaximumHeight(hgt);
+    d->labelPhotoDateTime->setMaximumHeight(hgt);
+    d->labelPhotoAperture->setMaximumHeight(hgt);
+    d->labelPhotoFocalLenght->setMaximumHeight(hgt);
+    d->labelPhotoExposureTime->setMaximumHeight(hgt);
+    d->labelPhotoSensitivity->setMaximumHeight(hgt);
+    d->labelPhotoExposureMode->setMaximumHeight(hgt);
+    d->labelPhotoFlash->setMaximumHeight(hgt);
+    d->labelPhotoWhiteBalance->setMaximumHeight(hgt);
 
     // --------------------------------------------------
 
Index: imageproperties/imagepropertiestab.cpp
===================================================================
--- imageproperties/imagepropertiestab.cpp	(révision 656709)
+++ imageproperties/imagepropertiestab.cpp	(copie de travail)
@@ -226,9 +226,54 @@
     d->labelPhotoFlash          = new KSqueezedTextLabel(0, d->settingsArea);
     d->labelPhotoWhiteBalance   = new KSqueezedTextLabel(0, d->settingsArea);
 
+    int hgt = fontMetrics().height()+2;
     d->title->setAlignment(Qt::AlignCenter);
+    d->file->setMaximumHeight(hgt);
+    d->folder->setMaximumHeight(hgt);
+    d->modifiedDate->setMaximumHeight(hgt);
+    d->size->setMaximumHeight(hgt);
+    d->owner->setMaximumHeight(hgt);
+    d->permissions->setMaximumHeight(hgt);
+    d->labelFile->setMaximumHeight(hgt);
+    d->labelFolder->setMaximumHeight(hgt);
+    d->labelFileModifiedDate->setMaximumHeight(hgt);
+    d->labelFileSize->setMaximumHeight(hgt);
+    d->labelFileOwner->setMaximumHeight(hgt);
+    d->labelFilePermissions->setMaximumHeight(hgt);
+
     d->title2->setAlignment(Qt::AlignCenter);
+    d->mime->setMaximumHeight(hgt);
+    d->dimensions->setMaximumHeight(hgt);
+    d->compression->setMaximumHeight(hgt);
+    d->bitDepth->setMaximumHeight(hgt);
+    d->colorMode->setMaximumHeight(hgt);
+    d->labelImageMime->setMaximumHeight(hgt);
+    d->labelImageDimensions->setMaximumHeight(hgt);
+    d->labelImageCompression->setMaximumHeight(hgt);
+    d->labelImageBitDepth->setMaximumHeight(hgt);
+    d->labelImageColorMode->setMaximumHeight(hgt);
+
     d->title3->setAlignment(Qt::AlignCenter);
+    d->make->setMaximumHeight(hgt);
+    d->model->setMaximumHeight(hgt);
+    d->photoDate->setMaximumHeight(hgt);
+    d->aperture->setMaximumHeight(hgt);
+    d->focalLength->setMaximumHeight(hgt);
+    d->exposureTime->setMaximumHeight(hgt);
+    d->sensitivity->setMaximumHeight(hgt);
+    d->exposureMode->setMaximumHeight(hgt);
+    d->flash->setMaximumHeight(hgt);
+    d->whiteBalance->setMaximumHeight(hgt);
+    d->labelPhotoMake->setMaximumHeight(hgt);
+    d->labelPhotoModel->setMaximumHeight(hgt);
+    d->labelPhotoDateTime->setMaximumHeight(hgt);
+    d->labelPhotoAperture->setMaximumHeight(hgt);
+    d->labelPhotoFocalLenght->setMaximumHeight(hgt);
+    d->labelPhotoExposureTime->setMaximumHeight(hgt);
+    d->labelPhotoSensitivity->setMaximumHeight(hgt);
+    d->labelPhotoExposureMode->setMaximumHeight(hgt);
+    d->labelPhotoFlash->setMaximumHeight(hgt);
+    d->labelPhotoWhiteBalance->setMaximumHeight(hgt);
 
     // --------------------------------------------------
 
Index: widgets/common/sidebar.cpp
===================================================================
--- widgets/common/sidebar.cpp	(révision 656709)
+++ widgets/common/sidebar.cpp	(copie de travail)
@@ -90,7 +90,7 @@
 void Sidebar::setSplitter(QSplitter *sp)
 {
 #if KDE_IS_VERSION(3,3,0)
-    setStyle(KMultiTabBar::KDEV3ICON);
+    setStyle(KMultiTabBar::VSNET);
 #else
     setStyle(KMultiTabBar::KDEV3);
 #endif