Index: mimefilter.h
===================================================================
--- mimefilter.h	(revision 743485)
+++ mimefilter.h	(working copy)
@@ -5,7 +5,7 @@
  *
  * Date        : 2007-10-22
  * Description : a widget to filter album contents by type mime
- * 
+ *
  * Copyright (C) 2007 by Gilles Caulier <caulier dot gilles at gmail dot com>
  *
  * This program is free software; you can redistribute it
@@ -13,7 +13,7 @@
  * Public License as published by the Free Software Foundation;
  * either version 2, or (at your option)
  * any later version.
- * 
+ *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@@ -36,12 +36,13 @@
 class MimeFilter : public QComboBox
 {
     Q_OBJECT
-    
+
 public:
 
     enum TypeMimeFilter
     {
-        AllFiles = 0,  
+        AllFiles = 0,
+        NoRAWFiles,
         JPGFiles,
         PNGFiles,
         TIFFiles,
Index: albumlister.cpp
===================================================================
--- albumlister.cpp	(revision 743485)
+++ albumlister.cpp	(working copy)
@@ -8,7 +8,7 @@
  *
  * Copyright (C) 2004-2005 by Renchi Raju <renchi@pooh.tam.uiuc.edu>
  * Copyright (C) 2007 by Gilles Caulier <caulier dot gilles at gmail dot com>
- * Copyright (C) 2007 by Arnd Baecker <arnd dot baecker at web dot de> 
+ * Copyright (C) 2007 by Arnd Baecker <arnd dot baecker at web dot de>
  *
  * This program is free software; you can redistribute it
  * and/or modify it under the terms of the GNU General
@@ -88,7 +88,7 @@
 
     bool                            untaggedFilter;
 
-    int                             ratingFilter; 
+    int                             ratingFilter;
     int                             recurseAlbums;
     int                             recurseTags;
 
@@ -231,7 +231,7 @@
     d->filterTimer->start(100, true);
 }
 
-void AlbumLister::setTagFilter(const QValueList<int>& tags, const MatchingCondition& matchingCond, 
+void AlbumLister::setTagFilter(const QValueList<int>& tags, const MatchingCondition& matchingCond,
                                bool showUnTagged)
 {
     d->tagFilter      = tags;
@@ -284,7 +284,7 @@
         QValueList<int> tagIDs = info->tagIDs();
         QValueList<int>::iterator it;
 
-        if (d->matchingCond == OrCondition)        
+        if (d->matchingCond == OrCondition)
         {
             for (it = d->tagFilter.begin(); it != d->tagFilter.end(); ++it)
             {
@@ -304,7 +304,7 @@
                 if (!tagIDs.contains(*it))
                     break;
             }
-    
+
             if (it == d->tagFilter.end())
                 match = true;
         }
@@ -327,7 +327,7 @@
 
     //-- Filter by rating ---------------------------------------------------------
 
-    if (d->ratingFilter >= 0) 
+    if (d->ratingFilter >= 0)
     {
         if (d->ratingCond == GreaterEqualCondition)
         {
@@ -360,11 +360,11 @@
     QFileInfo fi(info->filePath());
     QString mimeType = fi.extension(false).upper();
 
-    switch(d->mimeTypeFilter) 
+    switch(d->mimeTypeFilter)
     {
         case MimeFilter::JPGFiles:
         {
-            if (mimeType != QString("JPG") && mimeType != QString("JPE") && 
+            if (mimeType != QString("JPG") && mimeType != QString("JPE") &&
                 mimeType != QString("JPEG"))
                 match = false;
             break;
@@ -381,6 +381,13 @@
                 match = false;
             break;
         }
+        case MimeFilter::NoRAWFiles:
+        {
+            QString rawFilesExt(AlbumSettings::instance()->getRawFileFilter());
+            if (rawFilesExt.upper().contains(mimeType))
+                match = false;
+            break;
+        }
         case MimeFilter::RAWFiles:
         {
             QString rawFilesExt(AlbumSettings::instance()->getRawFileFilter());
@@ -481,7 +488,7 @@
     QPtrList<ImageInfo> deleteFilteredItemsList;
     ImageInfo *item      = 0;
     bool atleastOneMatch = false;
-    
+
     for (ImageInfoListIterator it(d->itemList);
          (item = it.current()); ++it)
     {
@@ -496,9 +503,9 @@
             if (item->getViewItem())
                 deleteFilteredItemsList.append(item);
         }
-        
+
         if (foundText)
-            atleastOneMatch = true;                
+            atleastOneMatch = true;
     }
 
     // This takes linear time - and deleting seems to take longer. Set wait cursor for large numbers.
@@ -554,7 +561,7 @@
 {
     if (data.isEmpty())
         return;
-        
+
     bool    foundText = false;
     Q_LLONG imageID;
     int     albumID;
Index: mimefilter.cpp
===================================================================
--- mimefilter.cpp	(revision 743485)
+++ mimefilter.cpp	(working copy)
@@ -5,7 +5,7 @@
  *
  * Date        : 2007-10-22
  * Description : a widget to filter album contents by type mime
- * 
+ *
  * Copyright (C) 2007 by Gilles Caulier <caulier dot gilles at gmail dot com>
  *
  * This program is free software; you can redistribute it
@@ -13,7 +13,7 @@
  * Public License as published by the Free Software Foundation;
  * either version 2, or (at your option)
  * any later version.
- * 
+ *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
@@ -53,8 +53,9 @@
           : QComboBox(parent)
 {
     d = new MimeFilterPriv;
-    insertItem( i18n("All Files"),    AllFiles );
-    insertItem( i18n("JPEG Files"),    JPGFiles );
+    insertItem( i18n("All files"),    AllFiles );
+    insertItem( i18n("No RAW files"),    NoRAWFiles );
+    insertItem( i18n("JPEG files"),    JPGFiles );
     insertItem( i18n("PNG files"),    PNGFiles );
     insertItem( i18n("TIFF files"),    TIFFiles );
     insertItem( i18n("RAW files"),    RAWFiles );
@@ -62,13 +63,13 @@
     insertItem( i18n("Audio files"),  AudioFiles );
 
     QToolTip::add(this, i18n("Mime type filter"));
-    QWhatsThis::add(this, i18n("Select here the mime type pattern used to filter albums contents"));
+    QWhatsThis::add(this, i18n("Select the file types (mime type) you want to show"));
 
     setMimeFilter(AllFiles);
 }
 
 MimeFilter::~MimeFilter()
-{    
+{
     delete d;
 }
 