Index: utilities/setup/setupidentity.cpp
===================================================================
--- utilities/setup/setupidentity.cpp	(revision 871127)
+++ utilities/setup/setupidentity.cpp	(working copy)
@@ -81,21 +81,21 @@
     d->authorEdit->setClearButtonShown(true);
     d->authorEdit->setMaxLength(32);
     label1->setBuddy(d->authorEdit);
-    d->authorEdit->setWhatsThis( i18n("<p>This field should contain your name, or the name of the person who created the photograph. "
-                                         "If it is not appropriate to add the name of the photographer (for example, if the identify of "
-                                         "the photographer needs to be protected) the name of a company or organization can also be used. "
-                                         "Once saved, this field should not be changed by anyone. This field does not support the use of "
-                                         "commas or semi-colons as separator. \nThis field is limited to 32 ASCII characters.</p>"));
+    d->authorEdit->setWhatsThis( i18n("<p>This field should contain the name of the person or entity who will be credited as taking the image. "
+                                         "For privacy reasons, the name of a company or organization can be substituted here."
+                                         "It's a good idea to keep this field constant across images, as this can make "
+					 "image attribution much easier in the long run. \nThis field does not support the use of "
+					 "commas or semi-colons and is limited to 32 characters (ASCII).</p>"));
 
     QLabel *label2     = new QLabel(i18n("Author Title:"), photographerIdGroup);
     d->authorTitleEdit = new KLineEdit(photographerIdGroup);
     d->authorTitleEdit->setClearButtonShown(true);
     d->authorTitleEdit->setMaxLength(32);
     label2->setBuddy(d->authorTitleEdit);
-    d->authorTitleEdit->setWhatsThis( i18n("<p>This field should contain the job title of the photographer. Examples might include "
-                                              "titles such as: Staff Photographer, Freelance Photographer, or Independent Commercial "
-                                              "Photographer. Since this is a qualifier for the Author field, the Author field must also "
-                                              "be filled out. \nThis field is limited to 32 ASCII characters.</p>"));
+    d->authorTitleEdit->setWhatsThis( i18n("<p>This field should contain the specific title of the photographer. Examples include: "
+                                              "Staff Photographer, Freelance Photographer, or Independent Commercial "
+                                              "Photographer. Since this builds upon the info in the Author field, that must also "
+                                              "be filled out. \nThis field is limited to 32 characters (ASCII).</p>"));
 
     grid->addWidget(label1,             0, 0, 1, 1);
     grid->addWidget(d->authorEdit,      0, 1, 1, 1);
@@ -119,7 +119,7 @@
                                       "such as Reuters or the Associated Press, these organizations could be listed here as they are "
                                       "\"providing\" the image for use by others. If the image is a stock photograph, then the group "
                                       "(agency) involved in supplying the image should be listed here. "
-                                      "\nThis field is limited to 32 ASCII characters.</p>"));
+                                      "\nThis field is limited to 32 characters (ASCII).</p>"));
 
     QLabel *label4 = new QLabel(i18n("Source:"), creditsGroup);
     d->sourceEdit  = new KLineEdit(creditsGroup);
@@ -127,23 +127,23 @@
     d->sourceEdit->setMaxLength(32);
     label4->setBuddy(d->sourceEdit);
     d->sourceEdit->setWhatsThis( i18n("<p>The Source field should be used to identify the original owner or copyright holder of the "
-                                      "photograph. The value of this field should never be changed after the information is entered "
-                                      "following the image's creation. While not yet enforced by the custom panels, you should consider "
-                                      "this to be a \"write-once\" field. The source could be an individual, an agency, or a "
-                                      "member of an agency. To aid in later searches, it is suggested to separate any slashes "
+                                      "image. It's a good idea to keep this field constant across images, as this can make "
+				      "image attribution much easier in the long run. "
+                                      "The source could be an individual, an agency, or a "
+                                      "member of an agency. To aid in later searches, we suggest that you separate any slashes "
                                       "\"/\" with a blank space. Use the form \"photographer / agency\" rather than "
                                       "\"photographer/agency.\" Source may also be different from Creator and from the names "
-                                      "listed in the Copyright Notice.\nThis field is limited to 32 ASCII characters.</p>"));
+                                      "listed in the Copyright Notice.\nThis field is limited to 32 characters (ASCII).</p>"));
 
     QLabel *label5   = new QLabel(i18n("Copyright:"), creditsGroup);
     d->copyrightEdit = new KLineEdit(creditsGroup);
     d->copyrightEdit->setClearButtonShown(true);
     d->copyrightEdit->setMaxLength(128);
     label5->setBuddy(d->copyrightEdit);
-    d->copyrightEdit->setWhatsThis( i18n("<p>The Copyright Notice should contain any necessary copyright notice for claiming the intellectual "
-                                         "property, and should identify the current owner(s) of the copyright for the photograph. Usually, "
-                                         "this would be the photographer, but if the image was done by an employee or as work-for-hire, "
-                                         "then the agency or company should be listed. Use the form appropriate to your country. USA: "
+    d->copyrightEdit->setWhatsThis( i18n("<p>The Copyright Notice should contain any necessary copyright notice for claiming any intellectual "
+                                         "property contained within, and should identify the current owner(s) of the copyright for the photograph. Often, "
+                                         "this will be the photographer, but if the image was done by an employee or as work-for-hire, "
+                                         "then the hiring agency or company should be listed. Use the form appropriate to your country. USA: "
                                          "&copy; {date of first publication} name of copyright owner, as in \"&copy;2005 John Doe.\" "
                                          "Note, the word \"copyright\" or the abbreviation \"copr\" may be used in place of the &copy; symbol. "
                                          "In some foreign countries only the copyright symbol is recognized and the abbreviation does not work. "
@@ -166,12 +166,12 @@
 
     // --------------------------------------------------------
 
-    QLabel *note = new QLabel(i18n("<b>Note: These information are used to set "
+    QLabel *note = new QLabel(i18n("<b>Note: These fields are used to set "
                    "<b><a href='http://en.wikipedia.org/wiki/Extensible_Metadata_Platform'>XMP</a></b> "
-                   "and <b><a href='http://en.wikipedia.org/wiki/IPTC'>IPTC</a></b> tags contents. "
-                   "There is no limitation with XMP, but take a care than IPTC text tags "
+                   "and <b><a href='http://en.wikipedia.org/wiki/IPTC'>IPTC</a></b> tag content. "
+                   "There is no text limitations with XMP data, but IPTC text tags "
                    "only support the printable <b><a href='http://en.wikipedia.org/wiki/Ascii'>ASCII</a></b> "
-                   "characters set and limit strings size. "
+                   "character set and a limited text length. "
                    "Use contextual help for details.</b>"), this);
     note->setOpenExternalLinks(true);
     note->setWordWrap(true);