Index: utilities/setup/setupmime.cpp
===================================================================
--- utilities/setup/setupmime.cpp	(revision 871422)
+++ utilities/setup/setupmime.cpp	(working copy)
@@ -89,11 +89,17 @@
     // --------------------------------------------------------
 
     QLabel *explanationLabel = new QLabel;
-    explanationLabel->setText(i18n("<p>Digikam supports the image formats that digital cameras produce, "
-                                   "a few other important image formats, as well as common video and audio formats.</p> "
-                                   "<p>If you have special needs, you can adjust here the list of supported "
-                                   "formats. Add your file extensions to the lists of either image, "
-                                   "audio or video files.</p>"));
+    explanationLabel->setText(i18n("<p>Digikam attempts to support all of the image formats that digital cameras produce, "
+                                   "while being able to handle a few other important video and audio formats.</p> "
+                                   "<p>You can add to the already-appreciable list of formats that Digikam handles by "
+                                   "adding the extension of the type you want to add. For example, to handle the .abc video format, "
+                                   "you would add \"abc\" in the \"Movie Files\" line below. Multiple extensions need to be separated by a space."
+                                   "<P>You can also remove file formats that are shown by default "
+				   "by putting a minus sign in front of the extension: \"-gif\", which would remove all GIF files from your Album view and any trace of them in your database. "
+				   "They would not be deleted, just not shown in Digikam.</p>"
+				   "To revert to the default list of formats, click the arrow to the right of the line."
+                                   "<p><B>Warning:</b> Removing files from the database means losing "
+                                   "all of their tags and ratings!<p>"));
     explanationLabel->setWordWrap(true);
 
     // --------------------------------------------------------
@@ -105,18 +111,18 @@
     logoLabel1->setPixmap(DesktopIcon("image-jpeg2000"));
 
     d->imageFileFilterLabel = new QLabel(imageFileFilterBox);
-    d->imageFileFilterLabel->setText(i18n("Customize &image file extensions (<a href=image>Current settings</a>):"));
+    d->imageFileFilterLabel->setText(i18n("Customize &image file extensions (<a href=image>Currently-supported types</a>):"));
 
     KHBox *hbox1 = new KHBox(imageFileFilterBox);
     d->imageFileFilterEdit = new QLineEdit(hbox1);
-    d->imageFileFilterEdit->setWhatsThis( i18n("<p>Here you can add extra extensions of image files (including RAW files) "
-                                               "to be displayed in Albums. Just write \"xyz abc\" "
-                                               "to support files with the *.xyz and *.abc extensions. "
-                                               "You can as well remove file formats that are supported by default "
-                                               "by prepending a minus sign: \"-gif\" will remove all GIF files "
-                                               "from the database.</p>"
-                                               "<p><b>Attention:</b> Removing files from the database means losing "
-                                               "all their tags and ratings!<p>"));
+    d->imageFileFilterEdit->setWhatsThis( i18n("<p>Here you can add the extensions of image files (including RAW files) "
+                                               "to be displayed in the Album view. Just put \"xyz abc\" "
+                                               "to display files with the xyz and abc extensions in your Album view. "
+                                               "You can also remove file formats that are shown by default "
+                                               "by putting a minus sign in front of the extension: \"-gif\", which would remove all GIF files from your Album view and any trace of them in your database. "
+                                               "They would not be deleted, just not shown in Digikam.</p>"
+                                               "<p><B>Warning:</b> Removing files from the database means losing "
+                                               "all of their tags and ratings!<p>"));
     d->imageFileFilterLabel->setBuddy(d->imageFileFilterEdit);
     hbox1->setStretchFactor(d->imageFileFilterEdit, 10);
 
@@ -140,18 +146,20 @@
     logoLabel2->setPixmap(DesktopIcon("video-mpeg"));
 
     d->movieFileFilterLabel = new QLabel(movieFileFilterBox);
-    d->movieFileFilterLabel->setText(i18n("Customize &movie file extensions (<a href=video>Current settings</a>):"));
+    d->movieFileFilterLabel->setText(i18n("Customize &movie file extensions (<a href=video>Currently-supported types</a>):"));
 
     KHBox *hbox2 = new KHBox(movieFileFilterBox);
     d->movieFileFilterEdit = new QLineEdit(hbox2);
     d->movieFileFilterEdit->setWhatsThis( i18n("<p>Here you can add extra extensions of video files "
-                                               "to be displayed in Albums. Just write \"xyz abc\" "
+                                               "to be displayed in your Album view. Just write \"xyz abc\" "
                                                "to support files with the *.xyz and *.abc extensions. "
                                                "Clicking on these files will "
                                                "play them in an embedded KDE movie player. "
                                                "You can as well remove file formats that are supported by default "
-                                               "by prepending a minus sign: \"-avi\" will remove all AVI files "
-                                               "from the database.</p>"));
+                                               "by putting a minus sign in front of the extension: \"-avi\", which would remove all AVI files from your Album view and any trace of them in your database. "
+                                               "They would not be deleted, just not shown in Digikam.</p>"
+                                               "<p><B>Warning:</b> Removing files from the database means losing "
+                                               "all of their tags and ratings!<p>"));
     d->movieFileFilterLabel->setBuddy(d->movieFileFilterEdit);
     hbox2->setStretchFactor(d->movieFileFilterEdit, 10);
 
@@ -175,18 +183,20 @@
     logoLabel3->setPixmap(DesktopIcon("audio-basic"));
 
     d->audioFileFilterLabel = new QLabel(audioFileFilterBox);
-    d->audioFileFilterLabel->setText(i18n("Customize &audio file extensions (<a href=audio>Current settings</a>):"));
+    d->audioFileFilterLabel->setText(i18n("Customize &audio file extensions (<a href=audio>Currently-supported types</a>):"));
 
     KHBox *hbox3 = new KHBox(audioFileFilterBox);
     d->audioFileFilterEdit = new QLineEdit(hbox3);
     d->audioFileFilterEdit->setWhatsThis( i18n("<p>Here you can add extra extensions of audio files "
-                                               "to be displayed in Albums. Just write \"xyz abc\" "
-                                               "to support files with the *.xyz and *.abc extensions. "
+                                               "to be displayed in your Album view. Just write \"mp7\" "
+                                               "to support files with the *.mp7 extension. "
                                                "Clicking on these files will "
-                                               "play them with an embedded KDE audio player. "
-                                               "You can as well remove file formats that are supported by default "
-                                               "by prepending a minus sign: \"-mp3\" will for example remove all MP3 files "
-                                               "from the database.</p>"));
+                                               "play them in an embedded KDE audio player. "
+                                               "You can also remove file formats that are supported by default "
+                                               "by putting a minus sign in front of the extension: \"-ogg\", which would remove all OGG files from your Album view and any trace of them in your database. "
+                                               "They would not be deleted, just not shown in Digikam.</p>"
+                                               "<p><B>Warning:</b> Removing files from the database means losing "
+                                               "all of their tags and ratings!<p>"));
     d->audioFileFilterLabel->setBuddy(d->audioFileFilterEdit);
     hbox3->setStretchFactor(d->audioFileFilterEdit, 10);
 
@@ -297,7 +307,7 @@
                                                 "These are very common formats. If you have images in your collection "
                                                 "with these formats, they will be removed from the database and you will "
                                                 "lose all information about them, including rating and tags. "
-                                                "Are you sure you want to apply your changes about the supported image formats?",
+                                                "Are you sure you want to apply your changes and lose the support for these formats?",
                                                 removedImageFormats.join(" "))
                                               );
         if (result != KMessageBox::Yes)