diff --git a/digikam/digikamapp.cpp b/digikam/digikamapp.cpp
index defc378..b4d3856 100644
--- a/digikam/digikamapp.cpp
+++ b/digikam/digikamapp.cpp
@@ -858,7 +858,7 @@ void DigikamApp::setupActions()
 
     // -----------------------------------------------------------
 
-    d->zoomTo100percents = new KAction(KIcon("zoom-original"), i18n("Zoom to 1:1"), this);
+    d->zoomTo100percents = new KAction(KIcon("zoom-original"), i18n("Zoom to Full"), this);
     d->zoomTo100percents->setShortcut(Qt::ALT+Qt::CTRL+Qt::Key_0);       // NOTE: Photoshop 7 use ALT+CTRL+0
     connect(d->zoomTo100percents, SIGNAL(triggered()), d->view, SLOT(slotZoomTo100Percents()));
     actionCollection()->addAction("album_zoomto100percents", d->zoomTo100percents);
@@ -919,7 +919,7 @@ void DigikamApp::setupActions()
 
     // -----------------------------------------------------------
 
-    d->libsInfoAction = new KAction(KIcon("help-about"), i18n("Components info"), this);
+    d->libsInfoAction = new KAction(KIcon("help-about"), i18n("Component info"), this);
     connect(d->libsInfoAction, SIGNAL(triggered()), this, SLOT(slotComponentsInfo()));
     actionCollection()->addAction("help_librariesinfo", d->libsInfoAction);
 
@@ -1330,13 +1330,13 @@ void DigikamApp::cameraAutoDetect()
 
 void DigikamApp::loadCameras()
 {
-    d->cameraSolidMenu->menuAction()->setText(i18n("Digital Cameras"));
+    d->cameraSolidMenu->menuAction()->setText(i18n("Cameras (Auto-detected)"));
     d->cameraSolidMenu->menuAction()->setIcon(KIcon("camera-photo"));
     d->usbMediaMenu->menuAction()->setText(i18n("USB Storage Devices"));
     d->usbMediaMenu->menuAction()->setIcon(KIcon("drive-removable-media-usb"));
     d->cardReaderMenu->menuAction()->setText(i18n("Card Readers"));
     d->cardReaderMenu->menuAction()->setIcon(KIcon("media-flash-smart-media"));
-    d->manuallyAddedCamerasMenu->menuAction()->setText(i18n("Cameras Added Manually"));
+    d->manuallyAddedCamerasMenu->menuAction()->setText(i18n("Cameras (Add)"));
     d->manuallyAddedCamerasMenu->menuAction()->setIcon(KIcon("preferences-other"));
 
     actionCollection()->addAction("camera_solid", d->cameraSolidMenu->menuAction());
diff --git a/digikam/welcomepageview.cpp b/digikam/welcomepageview.cpp
index e3332b4..d110c39 100644
--- a/digikam/welcomepageview.cpp
+++ b/digikam/welcomepageview.cpp
@@ -95,23 +95,25 @@ void WelcomePageView::slotUrlOpen(const KUrl& url)
 QString WelcomePageView::infoPage()
 {
     QStringList newFeatures;
-    newFeatures << i18n("Designed for KDE4");
-    newFeatures << i18n("Hardware handling using KDE4 Solid interface");
-    newFeatures << i18n("Multimedia files handling using KDE4 Phonon interface");
-    newFeatures << i18n("Geolocation performed using KDE4 Marble interface");
+    newFeatures << i18n("Designed from the ground-up for KDE4, using KDE4 technology:"
+                        "<ul><li>Hardware taming with KDE4's Solid interface</li>"
+                        "<li>More comprehensive multimedia file handling using KDE4's Phonon interface</li>"
+                        "<li>Easy Geolocation comes to the table with KDE4's Marble interface</li></ul>");
     newFeatures << i18n("XMP metadata support");
-    newFeatures << i18n("TIFF/EP RAW files metadata editing");
-    newFeatures << i18n("The database file can be stored on a customized place to support remote album library paths");
-    newFeatures << i18n("Support of multiple roots album paths");
-    newFeatures << i18n("Thumbnails-bar integration with preview mode and editor for easy navigation between images");
+    newFeatures << i18n("TIFF/EP RAW metadata editing");
+    newFeatures << i18n("Customizable file storage for the Digikam database, supporting remote albums");
+    newFeatures << i18n("Support of multiple root album paths (no more importing into one giant album)");
+    newFeatures << i18n("Thumbnail-bar integration for easy navigation and editing");
     newFeatures << i18n("Supports the latest camera RAW files");
-    newFeatures << i18n("A new camera interface");
-    newFeatures << i18n("A new tool to capture photographs from Camera");
-    newFeatures << i18n("A new tool based on LensFun library to fix lens defaults automatically");
-    newFeatures << i18n("A new tool to perform fuzzy searches based on sketch drawing template");
-    newFeatures << i18n("A new tool to perform advanced searches based on photo meta-information");
-    newFeatures << i18n("A new tool to perform searches over a map");
-    newFeatures << i18n("A new tool to find similar and duplicate images around collections");
+    newFeatures << i18n("New/revamped tools:"
+                        "<ul><li>Revamped camera import wizard</li>"
+                        "<li>LensFun: auto-correction of lens flaws tool</li>"
+                        "<li>Fuzzy searches based on hand-drawn sketches</li>"
+                        "<li>Advanced searches using image meta-information, like keywords and dates</li>"
+                        "<li>User-friendly map searching that gives you the power to search for global photo locations</li>"
+                        "<li>Duplicate image searches</li></ul>");
+    newFeatures << i18n("...and much more");
+
 
     QString featureItems;
     for ( int i = 0 ; i < newFeatures.count() ; i++ )
@@ -132,13 +134,13 @@ QString WelcomePageView::infoPage()
         "Welcome to digiKam %1"
         "</h2>"
 
-        "<p>digiKam is an open source photo management program. "
-        "It is designed to import, organize, enhance, search and export your "
-        "digital photographs on your computer.</p>"
+        "<p>digiKam is an open source photo management program "
+        "designed to import, organize, enhance, search and export your "
+        "digital images to and from your computer and the world.</p>"
 
-        "<p>You are currently in the Album view mode of digiKam. The Albums are the real "
-        "containers where your files are stored, they are identical with the folders "
-        "on disk.</p>"
+        "<p>Currently, you're in the Album view mode of digiKam. Albums are the places "
+        "where your files are stored, and are identical to the folders "
+        "on your hard disk.</p>"
 
         "<ul>"
             "<li>"
@@ -147,7 +149,7 @@ QString WelcomePageView::infoPage()
             "</li>"
             "<li>"
                 "The <a href=\"%3\">digiKam homepage</A> provides information about "
-                "new versions of digiKam"
+                "new versions of digiKam to get excited about."
             "</li>"
         "</ul>"
 
diff --git a/showfoto/setup/setupeditor.cpp b/showfoto/setup/setupeditor.cpp
index 1291d54..eac777c 100644
--- a/showfoto/setup/setupeditor.cpp
+++ b/showfoto/setup/setupeditor.cpp
@@ -188,9 +188,9 @@ SetupEditor::SetupEditor(QWidget* parent )
     KHBox* sortBox       = new KHBox(sortOptionsGroup);
     new QLabel(i18n("Sort images by:"), sortBox);
     d->sortOrderComboBox = new KComboBox(sortBox);
-    d->sortOrderComboBox->insertItem(0, i18n("File Date"));
-    d->sortOrderComboBox->insertItem(1, i18n("File Name"));
-    d->sortOrderComboBox->insertItem(2, i18n("File size"));
+    d->sortOrderComboBox->insertItem(0, i18n("Date"));
+    d->sortOrderComboBox->insertItem(1, i18n("Name"));
+    d->sortOrderComboBox->insertItem(2, i18n("Size on Disk"));
     d->sortOrderComboBox->setWhatsThis(i18n("Here, select whether newly-loaded "
                                             "images are sorted by their date, name, or size on disk."));
 
diff --git a/tips b/tips
index 3976059..344a958 100644
--- a/tips
+++ b/tips
@@ -75,7 +75,7 @@
 <img src="hicolor/32x32/apps/digikam.png">
 </td>
 <td>
-... that albums in digiKam are folders in your Album Library? So you can easily import your photos by simply copying them to your Album Library.
+... that albums in digiKam are folders in your Album Library? So you can easily import your photos by simply copying those folders to your Album Library. For example, under Microsoft Windows, pictures are often kept in "My Documents", in a folder called "My Pictures". Just copying this folder to your Album Library will import all of those images.
 </td>
 </tr>
 </table>
diff --git a/utilities/setup/setupmime.cpp b/utilities/setup/setupmime.cpp
index 111665e..839b7b8 100644
--- a/utilities/setup/setupmime.cpp
+++ b/utilities/setup/setupmime.cpp
@@ -89,11 +89,17 @@ SetupMime::SetupMime(QWidget* parent)
     // --------------------------------------------------------
 
     QLabel *explanationLabel = new QLabel;
-    explanationLabel->setText(i18n("<p>Digikam supports the image formats that digital cameras produce, "
-                                   "a few other important image formats, as well as common video and audio formats.</p> "
-                                   "<p>If you have special needs, you can adjust here the list of supported "
-                                   "formats. Add your file extensions to the lists of either image, "
-                                   "audio or video files.</p>"));
+    explanationLabel->setText(i18n("<p>Digikam attempts to support all of the image formats that digital cameras produce, "
+                                   "while being able to handle a few other important video and audio formats.</p> "
+                                   "<p>You can add to the already-appreciable list of formats that Digikam handles by "
+                                   "adding the extension of the type you want to add. For example, to handle the .abc video format, "
+                                   "you would add \"abc\" in the \"Movie Files\" line below. Multiple extensions need to be separated by a space.</p>"
+                                   "<p>You can also remove file formats that are shown by default "
+				   "by putting a minus sign in front of the extension: \"-gif\", which would remove all GIF files from your Album view and any trace of them in your database. "
+				   "They would not be deleted, just not shown in Digikam.</p>"
+				   "To revert to the default list of formats, click the arrow to the right of the line."
+                                   "<p><B>Warning:</b> Removing files from the database means losing "
+                                   "all of their tags and ratings!<p>"));
     explanationLabel->setWordWrap(true);
 
     // --------------------------------------------------------